#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include "text.h"
#include "txttool.h"
#include <gd.h>
#include <gdfontt.h>
#include <gdfonts.h>
#include <gdfontmb.h>
#include <gdfontl.h>
#include <gdfontg.h>

int text::parse_inputline(char *name, char *value) {
    FILE *file;
    int s;
    printf("text: %s: %s\n",name,value);
    if (strcmp(name, "text")==0) {
	strcpy(txt,value);
	return(0);
    } else if (strcmp(name, "font")==0) {
	s=atoi(value);
	if (s>0 && s<6) {
	    if (s==1) font=gdFontTiny;
	    if (s==2) font=gdFontSmall;
	    if (s==3) font=gdFontLarge;
	    if (s==4) font=gdFontMediumBold;
	    if (s==5) font=gdFontGiant;
	}
	return(0);
    } else if (strcmp(name, "color")==0) {
	color=strtol(value,(char**)NULL,16);
	return(0);
    } else if (strcmp(name, "height")==0) {
	height=atoi(value);
	return(0);
    } else if (strcmp(name, "width")==0) {
	width=atoi(value);
	return(0);
    }
    return(inputplugin::parse_inputline(name,value));
}

gdImagePtr* text::get_output() {
    char buffer[STRLEN_MAXTEXT];
    int x,y;
    int i;
    int fg, bg;
    printf("Text: gonna call parsetext for %s\n",txt);
    parsetext(txt,buffer);
//    printf("Text: get_output called for %s\n",buffer);
    if (strcmp(buffer,prevtxt)!=0) {
	strcpy(prevtxt,buffer);
	if (pic!=NULL) gdImageDestroy(pic);
	printf("Creating image ($ix%i)...\n",height, width);
	pic=gdImageCreate(width, height);
	bg=gdImageColorAllocate(pic,0,0,0);
	fg=gdImageColorAllocate(pic,(color>>16),((color>>8)&255),(color&255));
	gdImageColorTransparent(pic,bg);
	x=0; y=0;
	printf("Drawing...\n");
	for (i=0; i<strlen(buffer); i++) {
	    if (buffer[i]!=10) gdImageChar(pic,font,x,y,buffer[i],fg);
	    x+=font->w;
	    if (x>(width-font->w) || buffer[i]==10) {
		x=0;
		y+=font->h;
	    }
	}
    }
    return(&pic);
}

text::text() {
    printf("Created an yet uninitialized text obj\n");
    strcpy(txt,"");
    strcpy(prevtxt,"");
    font=gdFontLarge;
    height=20;
    width=100;
    pic=NULL;
}

text::~text() {
    if (pic!=NULL) gdImageDestroy(pic);
}
